#!/usr/bin/env python
import inspect
from isstring import isstring
from public import public


@public
def ispublic(obj, module=None):
    if not obj:
        return False
    if not module:
        module = inspect.getmodule(obj)
    if not module:
        err = "%s module is None" % obj
        raise TypeError(err)
    __all__ = module.__dict__.get("__all__", None)
    name = None
    if hasattr(obj, "__name__"):
        name = obj.__name__
    else:
        if isstring(obj):
            name = obj
        else:
            for _name, member in inspect.getmembers(module):
                if member == obj:
                    name = _name
                    continue
            if not name:
                err = "unknown name for %s" % obj
                raise TypeError(err)
    if __all__:
        return name in __all__
    return name.find("_") != 0
